<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable
                      class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search"
                       class="filter-item">搜索
            </el-button>
            <el-button @click="addRow" type="primary" icon="el-icon-plus"
                       class="filter-item">添加
            </el-button>
            <el-button @click="download" type="primary" icon="el-icon-download"
                       :loading="downloading" class="filter-item">导出EXCEL
            </el-button>
            <!--            <el-checkbox-group v-model="checkTypes">
                            <el-checkbox v-for="item in types" :key="item.value" :label="item.label" :value="item.value"
                                         class="cb" border size="mini" @change="change"
                            ></el-checkbox>
                        </el-checkbox-group>-->
            <el-select
                    v-model="checkType"
                    class="filter-item"
                    placeholder="筛选身份"
                    clearable
                    filterable
                    @change="getData"
            >
                <el-option
                        v-for="item in types"
                        :label="item.label"
                        :value="item.value"
                        :key="item.value"
                />
            </el-select>

        </div>
        <el-table :data="tableData" row-key="id" ref="table"
                  header-row-class-name="table-header-row"
                  header-cell-class-name="table-header-cell"
                  row-class-name="table-row" cell-class-name="table-cell"
                  :height="tableHeight">
            <el-table-column v-if="multipleMode" align="center" type="selection"
                             width="50">
            </el-table-column>
            <el-table-column prop="id" label="ID" width="100">
            </el-table-column>
            <el-table-column prop="userId" label="用户ID"
            >
            </el-table-column>
            <el-table-column prop="type" label="类型" :formatter="typesFormatter"
            >
            </el-table-column>
            <el-table-column prop="name" label="联系人"
            >
            </el-table-column>
            <el-table-column prop="phone" label="联系电话"
            >
            </el-table-column>
            <el-table-column prop="address" label="地址"
            >
            </el-table-column>
            <el-table-column prop="merName" label="商家名称"
            >
            </el-table-column>
            <el-table-column prop="category" label="商家类型"
            >
            </el-table-column>
            <el-table-column prop="remark" label="合作内容"
            >
            </el-table-column>
            <el-table-column prop="isPass" label="是否已联系"
            >
                <template slot-scope="{row}">
                    <el-tag :type="row.isPass?'':'info'">{{row.isPass!=null?row.isPass:false}}</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                    label="操作"
                    align="center"
                    fixed="right"
                    min-width="150">
                <template slot-scope="{row}">
                    <!-- <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>-->
                    <el-button @click="contactRow(row)" type="primary" size="mini" plain>已联系</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination background @size-change="onSizeChange"
                           @current-change="onCurrentChange" :current-page="page"
                           :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize"
                           layout="total, sizes, prev, pager, next, jumper"
                           :total="totalElements">
            </el-pagination>
        </div>

    </div>
</template>
<script>
    import {mapState} from "vuex";
    import pageableTable from "@/mixins/pageableTable";

    export default {
        name: 'CooperateApplyList',
        mixins: [pageableTable],
        created() {
            this.getData();
        },
        data() {
            return {
                multipleMode: false,
                search: "",
                url: "/cooperateApply/all",
                downloading: false,
                types: [{label: "商家", value: "MERCHANT"},
                    {label: "骑手", value: "RIDER"},
                    {label: "商务", value: "BUSINESS"}],
                checkType: "",
            }
        },
        computed: {
            selection() {
                return this.$refs.table.selection.map(i => i.id);
            }
        },
        methods: {
            typesFormatter(row, column, cellValue, index) {
                let selectedOption = this.types.find(i => i.value === cellValue);
                if (selectedOption) {
                    return selectedOption.label;
                }
                return '';
            },
            beforeGetData() {
                if (this.search) {
                    return {search: this.search};
                }
                if (this.checkType) {
                    return {
                        query: {
                            type: this.checkType
                        }
                    }
                }
            },
            toggleMultipleMode(multipleMode) {
                this.multipleMode = multipleMode;
                if (!multipleMode) {
                    this.$refs.table.clearSelection();
                }
            },
            addRow() {
                this.$router.push({
                    path: "/cooperateApplyEdit",
                    query: {
                        ...this.$route.query
                    }
                });
            },
            editRow(row) {
                this.$router.push({
                    path: "/cooperateApplyEdit",
                    query: {
                        id: row.id
                    }
                });
            },
            download() {
                this.downloading = true;
                this.$axios
                    .get("/cooperateApply/excel", {
                        responseType: "blob",
                        params: {size: 10000}
                    })
                    .then(res => {
                        console.log(res);
                        this.downloading = false;
                        const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                        const link = document.createElement("a");
                        link.href = downloadUrl;
                        link.setAttribute(
                            "download",
                            res.headers["content-disposition"].split("filename=")[1]
                        );
                        document.body.appendChild(link);
                        link.click();
                        link.remove();
                    })
                    .catch(e => {
                        console.log(e);
                        this.downloading = false;
                        this.$message.error(e.error);
                    });
            },
            operation1() {
                this.$notify({
                    title: '提示',
                    message: this.selection
                });
            },
            operation2() {
                this.$message('操作2');
            },
            deleteRow(row) {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/cooperateApply/del/${row.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                }).catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('删除取消');
                    } else {
                        this.$message.error('删除失败');
                    }
                })
            },
            contactRow(row) {
                this.$alert('确认已联系？', '提示').then(() => {
                    return this.$http.get('/cooperateApply/contact/', {
                        id: row.id
                    })
                }).then(() => {
                    this.$message.success('确认成功');
                    this.getData();
                }).catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('取消确认');
                    } else {
                        this.$message.error('确认失败');
                    }
                })
            },

        }
    }
</script>
<style lang="less" scoped>

    .cb {
        margin: 2px;
    }
</style>
